unit Unit1;

{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

{ calculate distance of crossing diagonals in a cube}

interface

uses
{$IFnDEF FPC}
  Windows,
{$ELSE}
  LCLIntf, LCLType,
{$ENDIF}
  SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, HSButton;

type

  { TForm1 }

  TForm1 = class(TForm)
    GObtn: THSButton;
    Memo1: TMemo;
    Image1: TImage;
    procedure FormCreate(Sender: TObject);
    procedure GObtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
     LAP,LDQ, Ldistance : double;

implementation

{$IFnDEF FPC}
  {$R *.dfm}
{$ELSE}
  {$R *.lfm}
{$ENDIF}

type Txyz = record
             x : double;
             y : double;
             z : double;
            end;

var sina,cosa,sinb,cosb : double;//constants

    DQ : double;
    AP : double;
    PQ : double;
    lineNr : byte;

function APtoXYZ(L : double) : Txyz;
//calculate coordinates of P
begin
 with result do
  begin
   x := L*cosa*cosb;
   y := L*sinb;
   z := L*sina*cosb;
  end;
end;

function DQtoXYz(L : double) : Txyz;
//calculate coordinates of Q
begin
 with result do
  begin
   x := L*cosa;
   y := 0;
   z := 1 - L*sina;
  end;
end;

function distance(P,Q : double) : double;
//calculate length of PQ
var P3 : Txyz;
    Q3 : Txyz;
begin
 P3 := APtoxyz(P);
 Q3 := DQtoxyz(Q);
 result := sqrt(sqr(P3.x-Q3.x)+sqr(P3.y-Q3.y)+sqr(P3.z-Q3.z));
end;

function intstring(v,L : byte) : string;
//make string of length L from integer value v
//right text alignment
begin
 result := inttostr(v);
 while length(result) < L do insert(' ',result,1);
end;

function floatstring(v : double; dp,L : byte) : string;
//make string length L from float value v with decimal point at position dp
const ff ='0.0#####';
var i,pp : byte;
    s : string;
begin
 s := formatfloat(ff,v);
 pp := pos('.',s);
 if pp = 0 then pp := pos(',',s);
 for i := 1 to dp-pp do insert(' ',s,1);
 while length(s) < L do s := s + ' ';
 result := s;
end;

procedure addline;
//add interim result to memo1
var s : string;
begin
 s := intstring(lineNr,3);
 s := s + '  PQ=';
 s := s + floatstring(PQ,3,9);
 s := s + '  DQ=';
 s := s + floatstring(DQ,3,9);
 s := s + '  AP=';
 s := s + floatstring(AP,3,9);
 form1.Memo1.lines.add(s);
end;

procedure TForm1.GObtnClick(Sender: TObject);
const cm1 : array[1..9] of shortInt = (-1,0,1,-1,0,1,-1,0,1);
      cm2 : array[1..9] of shortInt = (-1,-1,-1,0,0,0,1,1,1);
var delta : double;
    oldPQ : double;
    mi,i  : byte;
    APm   : double;
    DQm   : double;
begin
 memo1.Clear;
 delta := 0.1;
 AP := 0;
 DQ := 0;
 oldPQ := 10;
 lineNr := 0;
 repeat
  mi := 5;
  for i := 1 to 9 do
   begin
    APm := AP + cm1[i]*delta;
    DQm := DQ + cm2[i]*delta;
    PQ := distance(APm,DQm);
    if PQ < oldPQ then
     begin
      LAP := APm;
      LDQ := DQm;
      Ldistance := PQ;
      mi := i;
      oldPQ := PQ;
     end;
   end;
  inc(lineNr);
  AP := LAP;
  DQ := LDQ;
  if mi = 5 then delta := delta/2;
  addLine;
 until (delta < 1e-6);
end;

procedure TForm1.FormCreate(Sender: TObject);
//set constants
begin
 sina := 0.5*sqrt(2);
 cosa := sina;
 sinb := 1/sqrt(3);
 cosb := sqrt(2)/sqrt(3);
end;

end.
